<template>
  <q-page padding>
    <div class="text-h5 q-mb-md">Listado de Certificados</div>

    <q-card class="q-mt-sm">
      <q-list bordered>
        <q-expansion-item icon="filter_alt" label="Filtros Avanzados">
          <template v-slot:header>
            <q-item-section> Filtros Avanzados </q-item-section>
            <q-item-section side v-if="ListadoStore.filtroActivado">
              <q-badge color="blue"> Existe un filtro aplicado </q-badge>
            </q-item-section>
          </template>
          <q-card>
            <q-card-section>
              <div class="q-col-gutter-md row">
                <q-input
                  class="col col-sm-2 col-xs-12"
                  v-model="ListadoStore.filtros.query"
                  label="Buscar"
                  stack-label
                  dense
                />

                <q-input
                  class="col col-sm-2 col-xs-12"
                  v-model="ListadoStore.filtros.numero"
                  label="Certificado Numero "
                  stack-label
                  dense
                />

                <q-input
                  class="col col-sm-2 col-xs-12"
                  v-model="ListadoStore.filtros.rango_desde"
                  label="Numero Desde"
                  stack-label
                  dense
                />

                <q-input
                  class="col col-sm-2 col-xs-12"
                  v-model="ListadoStore.filtros.rango_hasta"
                  label="Numero Hasta"
                  stack-label
                  dense
                />
              </div>
            </q-card-section>
            <q-card-actions align="right">
              <Download
                flat
                v-if="habilitarExport"
                url="/api/formacion/certificados"
                :parametros="ListadoStore.filtros"
                :nombre="
                  'Certificados del ' +
                  ListadoStore.filtros.rango_desde +
                  ' al ' +
                  ListadoStore.filtros.rango_hasta +
                  '.xlsx'
                "
                color="orange"
              >
                Exportar Rango
              </Download>

              <Download
                flat
                v-if="habilitarExport"
                url="/api/formacion/certificados/download-pdfs"
                :parametros="ListadoStore.filtros"
                :nombre="
                  'Certificados del ' +
                  ListadoStore.filtros.rango_desde +
                  ' al ' +
                  ListadoStore.filtros.rango_hasta +
                  '.zip'
                "
                color="orange"
              >
                Exportar PDFs
              </Download>

              <q-btn flat color="primary" @click="onFiltrar">Filtrar</q-btn>
              <q-btn flat color="red" @click="onResetFiltros">
                Borrar Filtro
              </q-btn>
            </q-card-actions>
          </q-card>
        </q-expansion-item>
      </q-list>
    </q-card>

    <q-card class="q-mt-sm">
      <q-table
        :dense="true"
        :rows="dataSet"
        :columns="columnas"
        row-key="uuid"
        v-model:pagination="ListadoStore.filtros"
        :loading="loading"
        @request="onPaginar"
      >
        <!--------------------------------------
            loading
          ---------------------------------------->
        <template v-slot:loading>
          <Loading showing />
        </template>

        <template v-slot:body-cell-cursante="props">
          <q-td :props="props">
            <KeepAlive>
              <PersonaDetalle :persona="props.row.persona" />
            </KeepAlive>
          </q-td>
        </template>
        <template v-slot:body-cell-certificado="props">
          <q-td :props="props">
            <q-chip
              class="max-w"
              v-if="props.row.anulado"
              dark
              size="sm"
              square
              color="red"
              label="Certificado Anulado"
            />
            <q-item class="max-w">
              <q-item-section>
                <q-item-label caption lines="1">
                  <span>Numero :</span>
                  {{ props.row.numero }}
                </q-item-label>

                <q-item-label caption lines="1">
                  <span>Emitido :</span>
                  {{ props.row.emitido }}
                </q-item-label>
                <q-item-label caption lines="2">
                  <span>Enviado :</span>
                  <b v-if="props.row.notificado">
                    <q-icon size="xs" name="check_circle" color="green" />
                    correctamente
                  </b>
                  <b v-if="!props.row.notificado">
                    <q-icon size="xs" name="schedule" color="warning" />
                    Pendiente
                  </b>
                </q-item-label>
                <q-item-label caption lines="3" v-if="props.row.notificado">
                  <span>Notificado via Mail :</span>
                  {{ props.row.notificado_fecha }}
                </q-item-label>
              </q-item-section>
            </q-item>
          </q-td>
        </template>

        <template v-slot:body-cell-experiencia="props">
          <q-td :props="props">
            <q-item class="max-w">
              <q-item-section>
                <q-item-label caption lines="1">
                  <span>Experincia :</span>
                  {{ props.row.meta_data.experincia }}
                </q-item-label>
                <q-item-label caption lines="2">
                  <span>Fecha :</span>
                  {{ props.row.meta_data.fecha }}
                </q-item-label>
                <q-item-label caption lines="3">
                  <span>Realizado :</span>
                  {{ props.row.meta_data.realizado }}
                </q-item-label>
                <q-item-label caption lines="4" v-if="props.row.meta_data.rama">
                  <span> Realizado : </span>
                  <ItemRama :rama="props.row.meta_data.rama" />
                </q-item-label>
              </q-item-section>
            </q-item>
          </q-td>
        </template>

        <template v-slot:body-cell-opciones="props">
          <q-td :props="props">
            <Download
              :color="props.row.anulado ? 'red' : 'green'"
              size="sm"
              :url="
                '/api/formacion/participantes/certificado/' +
                props.row.cursante_uuid
              "
              :nombre="
                'Certificado ' +
                props.row.numero +
                ' - ' +
                props.row.meta_data.experincia
              "
            >
              <i class="fas fa-file-pdf" />
              <template v-if="props.row.anulado">
                Certificado Anulado
              </template>
              <template v-else> Certificado </template>
            </Download>
          </q-td>
        </template>
      </q-table>
    </q-card>
  </q-page>
</template>

<script lang="ts">
import { defineComponent, onMounted, ref, reactive, computed } from 'vue';
import { QTableProps } from 'quasar';
import { AxiosResponse } from 'axios';
import { api } from 'src/boot/axios/index';
import PersonaDetalle from 'src/components/Personas/Detalle.vue';
import ItemRama from 'src/components/Util/ItemRama.vue';
import Loading from 'src/components/Loading.vue';
import { useCerificadosStore } from 'src/stores/formacion/certificadosStore';
import Download from 'components/Util/Download.vue';

// Defino las columnas de la tabla
const columnas: QTableProps['columns'] = [
  { name: 'cursante', label: 'Cursante', field: 'cursante', align: 'left' },
  {
    name: 'certificado',
    label: 'Certificado',
    field: 'certificado',
    align: 'right',
  },
  {
    name: 'experiencia',
    label: 'Experiencia',
    field: 'experiencia',
    align: 'left',
  },
  { name: 'opciones', label: 'Opciones', field: 'opciones', align: 'left' },
];

export default defineComponent({
  components: {
    Loading,
    PersonaDetalle,
    ItemRama,
    Download,
  },
  name: 'ListadoCertificados',
  setup() {
    const loading = ref(true);
    const ListadoStore = useCerificadosStore();

    const filtros = reactive({
      tipo: 'miseventos',
      area: null,
      estado: 'activos',
    });

    onMounted(() => {
      onRequest();
    });

    const habilitarExport = computed(() => {
      return (
        !ListadoStore.filtros.query &&
        !ListadoStore.filtros.numero &&
        ListadoStore.filtros.rango_desde &&
        ListadoStore.filtros.rango_hasta
      );
    });

    ////////////////////////////////////////////////////////////////////////////////
    //            GESTION DE PAGINADO Y GESTION DE DATOS
    ////////////////////////////////////////////////////////////////////////////////
    /*********************************************
     *  Metodo onPaginar
     *  Gestiona la configuracion del paginado.
     */
    function onPaginar(props: QTableProps) {
      ListadoStore.setPaginar(props);
      onRequest();
    }

    function onFiltrar() {
      ListadoStore.filtroActivado = true;
      ListadoStore.filtros.page = 1; // siempre que vuelvo a filtra, vuelvo a la pagina 1.
      onRequest();
    }

    /*********************************************
     *  Metoto onRequest
     *  encargado de obtener los datos desde la API
     */
    const dataSet = ref([]);
    function onRequest() {
      loading.value = true;
      api
        .get('/api/formacion/certificados', {
          params: ListadoStore.parametros,
        })
        .then((response: AxiosResponse) => {
          ListadoStore.setRowTotal(response.data.count); // Actializo la cantidas de row, por si cambio
          dataSet.value = response.data.data;
          loading.value = false;
        })
        .catch(() => {
          loading.value = false;
        });
    }

    /*********************************************
     *  Metoto resetFiltros
     *  Reinilizo los Filtros
     */
    function onResetFiltros() {
      ListadoStore.resetFiltros();
      // getCombosEquipos();
      // Recargo la info de la pagina !
      onRequest();
    }

    return {
      columnas,
      dataSet,
      ListadoStore,
      onRequest,
      onPaginar,
      onResetFiltros,
      onFiltrar,
      filtros,
      loading,
      habilitarExport,
    };
  },
});
</script>
